Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/libyahoo2.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -4318,11 +3948,10 @@
 		return;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_ADDBUDDY, YPACKET_STATUS_DEFAULT, yd->session_id);
-
-	if (msg != NULL) /* add message/request "it's me add me" */
+	pkt = yahoo_packet_new(YAHOO_SERVICE_ADDBUDDY, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+	if (msg != NULL)	/* add message/request "it's me add me" */
 		yahoo_packet_hash(pkt, 14, msg);
 	else
-		yahoo_packet_hash(pkt,14,"");
-
+		yahoo_packet_hash(pkt, 14, "");
 	yahoo_packet_hash(pkt, 65, group);
 	yahoo_packet_hash(pkt, 97, "1");
@@ -4334,6 +3963,4 @@
 	yahoo_packet_hash(pkt, 301, "319");
 	yahoo_packet_hash(pkt, 303, "319");
-
-
 	yahoo_send_packet(yid, pkt, 0);
 	yahoo_packet_free(pkt);
@@ -4342,13 +3969,15 @@
 void yahoo_remove_buddy(int id, const char *who, const char *group)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_REMBUDDY, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_REMBUDDY, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 
 	yahoo_packet_hash(pkt, 1, yd->user);
@@ -4359,54 +3988,71 @@
 }
 
-void yahoo_accept_buddy_ymsg13(int id,const char* me,const char* who){
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_confirm_buddy(int id, const char *who, int reject, const char *msg)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
-
-	if(!yid)
+	struct yahoo_packet *pkt;
+
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	struct yahoo_packet* pkt=NULL;
-	pkt= yahoo_packet_new(YAHOO_SERVICE_CONTACT_YMSG13,YAHOO_STATUS_AVAILABLE,0);
-
-	yahoo_packet_hash(pkt,1,me ?: yd->user);	
-	yahoo_packet_hash(pkt,5,who);
-	yahoo_packet_hash(pkt,13,"1");
-	yahoo_packet_hash(pkt,334,"0");
+	if (!yd->logged_in)
+		return;
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_AUTHORIZATION,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
+	yahoo_packet_hash(pkt, 1, yd->user);
+	yahoo_packet_hash(pkt, 5, who);
+	if (reject)
+		yahoo_packet_hash(pkt, 13, "2");
+	else {
+		yahoo_packet_hash(pkt, 241, "0");
+		yahoo_packet_hash(pkt, 13, "1");
+	}
+
+	yahoo_packet_hash(pkt, 334, "0");
+
+	if (reject) {
+		yahoo_packet_hash(pkt, 14, msg ? msg : "");
+		yahoo_packet_hash(pkt, 97, "1");
+	}
+
 	yahoo_send_packet(yid, pkt, 0);
 	yahoo_packet_free(pkt);
 }
 
-void yahoo_reject_buddy_ymsg13(int id,const char* me,const char* who,const char* msg){
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_ignore_buddy(int id, const char *who, int unignore)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
-
-	if(!yid)
+	struct yahoo_packet *pkt;
+
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	struct yahoo_packet* pkt=NULL;
-	pkt= yahoo_packet_new(YAHOO_SERVICE_CONTACT_YMSG13,YAHOO_STATUS_AVAILABLE,0);
-
-	yahoo_packet_hash(pkt,1,me ?: yd->user);	
-	yahoo_packet_hash(pkt,5,who);
-//	yahoo_packet_hash(pkt,241,YAHOO_PROTO_VER);
-	yahoo_packet_hash(pkt,13,"2");
-	yahoo_packet_hash(pkt,334,"0");
-	yahoo_packet_hash(pkt,97,"1");
-	yahoo_packet_hash(pkt,14,msg?:"");
-
+	if (!yd->logged_in)
+		return;
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_IGNORECONTACT,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
+	yahoo_packet_hash(pkt, 1, yd->user);
+	yahoo_packet_hash(pkt, 7, who);
+	yahoo_packet_hash(pkt, 13, unignore ? "2" : "1");
 	yahoo_send_packet(yid, pkt, 0);
 	yahoo_packet_free(pkt);
-
-}
-
-void yahoo_reject_buddy(int id, const char *who, const char *msg)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+}
+
+void yahoo_stealth_buddy(int id, const char *who, int unstealth)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
@@ -4415,50 +4061,9 @@
 		return;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_REJECTCONTACT, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_STEALTH_PERM,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
 	yahoo_packet_hash(pkt, 1, yd->user);
 	yahoo_packet_hash(pkt, 7, who);
-	yahoo_packet_hash(pkt, 14, msg);
-	yahoo_send_packet(yid, pkt, 0);
-	yahoo_packet_free(pkt);
-}
-
-void yahoo_ignore_buddy(int id, const char *who, int unignore)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
-	struct yahoo_data *yd;
-	struct yahoo_packet *pkt;
-
-	if(!yid)
-		return;
-	yd = yid->yd;
-
-	if (!yd->logged_in)
-		return;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_IGNORECONTACT, YAHOO_STATUS_AVAILABLE, yd->session_id);
-	yahoo_packet_hash(pkt, 1, yd->user);
-	yahoo_packet_hash(pkt, 7, who);
-	yahoo_packet_hash(pkt, 13, unignore?"2":"1");
-	yahoo_send_packet(yid, pkt, 0);
-	yahoo_packet_free(pkt);
-}
-
-void yahoo_stealth_buddy(int id, const char *who, int unstealth)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
-	struct yahoo_data *yd;
-	struct yahoo_packet *pkt;
-
-	if(!yid)
-		return;
-	yd = yid->yd;
-
-	if (!yd->logged_in)
-		return;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_STEALTH, YAHOO_STATUS_AVAILABLE, yd->session_id);
-	yahoo_packet_hash(pkt, 1, yd->user);
-	yahoo_packet_hash(pkt, 7, who);
-	yahoo_packet_hash(pkt, 31, unstealth?"2":"1");
+	yahoo_packet_hash(pkt, 31, unstealth ? "2" : "1");
 	yahoo_packet_hash(pkt, 13, "2");
 	yahoo_send_packet(yid, pkt, 0);
@@ -4466,42 +4071,44 @@
 }
 
-void yahoo_change_buddy_group(int id, const char *who, const char *old_group, const char *new_group)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_change_buddy_group(int id, const char *who, const char *old_group,
+	const char *new_group)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_ADDBUDDY, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_CHANGE_GROUP,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
 	yahoo_packet_hash(pkt, 1, yd->user);
+	yahoo_packet_hash(pkt, 302, "240");
+	yahoo_packet_hash(pkt, 300, "240");
 	yahoo_packet_hash(pkt, 7, who);
-	yahoo_packet_hash(pkt, 65, new_group);
-	yahoo_packet_hash(pkt, 14, " ");
+	yahoo_packet_hash(pkt, 224, old_group);
+	yahoo_packet_hash(pkt, 264, new_group);
+	yahoo_packet_hash(pkt, 301, "240");
+	yahoo_packet_hash(pkt, 303, "240");
 
 	yahoo_send_packet(yid, pkt, 0);
 	yahoo_packet_free(pkt);
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_REMBUDDY, YAHOO_STATUS_AVAILABLE, yd->session_id);
-	yahoo_packet_hash(pkt, 1, yd->user);
-	yahoo_packet_hash(pkt, 7, who);
-	yahoo_packet_hash(pkt, 65, old_group);
-	yahoo_send_packet(yid, pkt, 0);
-	yahoo_packet_free(pkt);
 }
 
 void yahoo_group_rename(int id, const char *old_group, const char *new_group)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_GROUPRENAME, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_GROUPRENAME,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
 	yahoo_packet_hash(pkt, 1, yd->user);
 	yahoo_packet_hash(pkt, 65, old_group);
@@ -4512,22 +4119,25 @@
 }
 
-void yahoo_conference_addinvite(int id, const char * from, const char *who, const char *room, const YList * members, const char *msg)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_conference_addinvite(int id, const char *from, const char *who,
+	const char *room, const YList *members, const char *msg)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFADDINVITE, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFADDINVITE,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
 	yahoo_packet_hash(pkt, 51, who);
 	yahoo_packet_hash(pkt, 57, room);
 	yahoo_packet_hash(pkt, 58, msg);
 	yahoo_packet_hash(pkt, 13, "0");
-	for(; members; members = members->next) {
+	for (; members; members = members->next) {
 		yahoo_packet_hash(pkt, 52, (char *)members->data);
 		yahoo_packet_hash(pkt, 53, (char *)members->data);
@@ -4540,19 +4150,22 @@
 }
 
-void yahoo_conference_invite(int id, const char * from, YList *who, const char *room, const char *msg)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_conference_invite(int id, const char *from, YList *who,
+	const char *room, const char *msg)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFINVITE, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFINVITE, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
 	yahoo_packet_hash(pkt, 50, yd->user);
-	for(; who; who = who->next) {
+	for (; who; who = who->next) {
 		yahoo_packet_hash(pkt, 52, (char *)who->data);
 	}
@@ -4566,21 +4179,24 @@
 }
 
-void yahoo_conference_logon(int id, const char *from, YList *who, const char *room)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_conference_logon(int id, const char *from, YList *who,
+	const char *room)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFLOGON, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
-	for(; who; who = who->next) {
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFLOGON, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
+	yahoo_packet_hash(pkt, 3, (from ? from : yd->user));
+	yahoo_packet_hash(pkt, 57, room);
+	for (; who; who = who->next)
 		yahoo_packet_hash(pkt, 3, (char *)who->data);
-	}
-	yahoo_packet_hash(pkt, 57, room);
 
 	yahoo_send_packet(yid, pkt, 0);
@@ -4589,20 +4205,23 @@
 }
 
-void yahoo_conference_decline(int id, const char * from, YList *who, const char *room, const char *msg)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_conference_decline(int id, const char *from, YList *who,
+	const char *room, const char *msg)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFDECLINE, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
-	for(; who; who = who->next) {
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFDECLINE,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
+	yahoo_packet_hash(pkt, 3, (from ? from : yd->user));
+	for (; who; who = who->next)
 		yahoo_packet_hash(pkt, 3, (char *)who->data);
-	}
 	yahoo_packet_hash(pkt, 57, room);
 	yahoo_packet_hash(pkt, 14, msg);
@@ -4613,20 +4232,24 @@
 }
 
-void yahoo_conference_logoff(int id, const char * from, YList *who, const char *room)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_conference_logoff(int id, const char *from, YList *who,
+	const char *room)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFLOGOFF, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
-	for(; who; who = who->next) {
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFLOGOFF, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
+	yahoo_packet_hash(pkt, 3, (from ? from : yd->user));
+	for (; who; who = who->next)
 		yahoo_packet_hash(pkt, 3, (char *)who->data);
-	}
+
 	yahoo_packet_hash(pkt, 57, room);
 
@@ -4636,24 +4259,28 @@
 }
 
-void yahoo_conference_message(int id, const char * from, YList *who, const char *room, const char *msg, int utf8)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_conference_message(int id, const char *from, YList *who,
+	const char *room, const char *msg, int utf8)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFMSG, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
-	for(; who; who = who->next) {
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CONFMSG, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
+	yahoo_packet_hash(pkt, 53, (from ? from : yd->user));
+	for (; who; who = who->next)
 		yahoo_packet_hash(pkt, 53, (char *)who->data);
-	}
+
 	yahoo_packet_hash(pkt, 57, room);
 	yahoo_packet_hash(pkt, 14, msg);
 
-	if(utf8)
+	if (utf8)
 		yahoo_packet_hash(pkt, 97, "1");
 
@@ -4670,5 +4297,5 @@
 	char buff[1024];
 
-	if(!yd)
+	if (!yd)
 		return;
 
@@ -4678,7 +4305,10 @@
 
 	if (chatroomid == 0) {
-		snprintf(url, 1024, "http://insider.msg.yahoo.com/ycontent/?chatcat=0");
+		snprintf(url, 1024,
+			"http://insider.msg.yahoo.com/ycontent/?chatcat=0");
 	} else {
-		snprintf(url, 1024, "http://insider.msg.yahoo.com/ycontent/?chatroom_%d=0",chatroomid);
+		snprintf(url, 1024,
+			"http://insider.msg.yahoo.com/ycontent/?chatroom_%d=0",
+			chatroomid);
 	}
 
@@ -4687,21 +4317,25 @@
 	inputs = y_list_prepend(inputs, yid);
 
-	yahoo_http_get(yid->yd->client_id, url, buff, _yahoo_http_connected, yid);
-}
-
-void yahoo_chat_logon(int id, const char *from, const char *room, const char *roomid)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	yahoo_http_get(yid->yd->client_id, url, buff, 0, 0,
+		_yahoo_http_connected, yid);
+}
+
+void yahoo_chat_logon(int id, const char *from, const char *room,
+	const char *roomid)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CHATONLINE, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CHATONLINE, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
 	yahoo_packet_hash(pkt, 109, yd->user);
 	yahoo_packet_hash(pkt, 6, "abcde");
@@ -4711,10 +4345,11 @@
 	yahoo_packet_free(pkt);
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CHATJOIN, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CHATJOIN, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
 	yahoo_packet_hash(pkt, 104, room);
 	yahoo_packet_hash(pkt, 129, roomid);
-	yahoo_packet_hash(pkt, 62, "2"); /* ??? */
+	yahoo_packet_hash(pkt, 62, "2");	/* ??? */
 
 	yahoo_send_packet(yid, pkt, 0);
@@ -4723,27 +4358,29 @@
 }
 
-
-void  yahoo_chat_message(int id, const char *from, const char *room, const char *msg, const int msgtype, const int utf8)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_chat_message(int id, const char *from, const char *room,
+	const char *msg, const int msgtype, const int utf8)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
 	char buf[2];
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_COMMENT, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
+	pkt = yahoo_packet_new(YAHOO_SERVICE_COMMENT, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
 	yahoo_packet_hash(pkt, 104, room);
 	yahoo_packet_hash(pkt, 117, msg);
-	
+
 	snprintf(buf, sizeof(buf), "%d", msgtype);
 	yahoo_packet_hash(pkt, 124, buf);
 
-	if(utf8)
+	if (utf8)
 		yahoo_packet_hash(pkt, 97, "1");
 
@@ -4753,19 +4390,20 @@
 }
 
-
 void yahoo_chat_logoff(int id, const char *from)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_CHATLOGOUT, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	yahoo_packet_hash(pkt, 1, (from?from:yd->user));
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CHATLOGOUT, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, (from ? from : yd->user));
 
 	yahoo_send_packet(yid, pkt, 0);
@@ -4776,14 +4414,16 @@
 void yahoo_buddyicon_request(int id, const char *who)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
 
-	if( !yid )
+	if (!yid)
 		return;
 
 	yd = yid->yd;
-	
-	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE, YAHOO_STATUS_AVAILABLE, 0);
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE, YPACKET_STATUS_DEFAULT,
+		0);
 	yahoo_packet_hash(pkt, 4, yd->user);
 	yahoo_packet_hash(pkt, 5, who);
@@ -4794,12 +4434,14 @@
 }
 
-void yahoo_send_picture_info(int id, const char *who, const char *url, int checksum)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_send_picture_info(int id, const char *who, const char *url,
+	int checksum)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
 	char checksum_str[10];
 
-	if( !yid )
+	if (!yid)
 		return;
 
@@ -4808,5 +4450,6 @@
 	snprintf(checksum_str, sizeof(checksum_str), "%d", checksum);
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE, YAHOO_STATUS_AVAILABLE, 0);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE, YPACKET_STATUS_DEFAULT,
+		0);
 	yahoo_packet_hash(pkt, 1, yd->user);
 	yahoo_packet_hash(pkt, 4, yd->user);
@@ -4822,10 +4465,11 @@
 void yahoo_send_picture_update(int id, const char *who, int type)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
 	char type_str[10];
 
-	if( !yid )
+	if (!yid)
 		return;
 
@@ -4834,5 +4478,6 @@
 	snprintf(type_str, sizeof(type_str), "%d", type);
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE_UPDATE, YAHOO_STATUS_AVAILABLE, 0);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE_UPDATE,
+		YPACKET_STATUS_DEFAULT, 0);
 	yahoo_packet_hash(pkt, 1, yd->user);
 	yahoo_packet_hash(pkt, 5, who);
@@ -4845,19 +4490,21 @@
 void yahoo_send_picture_checksum(int id, const char *who, int checksum)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
 	char checksum_str[10];
 
-	if( !yid )
+	if (!yid)
 		return;
 
 	yd = yid->yd;
-	
+
 	snprintf(checksum_str, sizeof(checksum_str), "%d", checksum);
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE_CHECKSUM, YAHOO_STATUS_AVAILABLE, 0);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE_CHECKSUM,
+		YPACKET_STATUS_DEFAULT, 0);
 	yahoo_packet_hash(pkt, 1, yd->user);
-	if( who != 0 )
+	if (who != 0)
 		yahoo_packet_hash(pkt, 5, who);
 	yahoo_packet_hash(pkt, 192, checksum_str);
@@ -4870,7 +4517,8 @@
 void yahoo_webcam_close_feed(int id, const char *who)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_webcam_user(id, who);
-
-	if(yid)
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_webcam_user(id, who);
+
+	if (yid)
 		yahoo_input_close(yid);
 }
@@ -4878,9 +4526,10 @@
 void yahoo_webcam_get_feed(int id, const char *who)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
+
+	if (!yid)
 		return;
 
@@ -4892,9 +4541,10 @@
 	 * The queue is popped in yahoo_process_webcam_key
 	 */
-	webcam_queue = y_list_append(webcam_queue, who?strdup(who):NULL);
+	webcam_queue = y_list_append(webcam_queue, who ? strdup(who) : NULL);
 
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_WEBCAM, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_WEBCAM, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 
 	yahoo_packet_hash(pkt, 1, yd->user);
@@ -4906,7 +4556,9 @@
 }
 
-void yahoo_webcam_send_image(int id, unsigned char *image, unsigned int length, unsigned int timestamp)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_WEBCAM);
+void yahoo_webcam_send_image(int id, unsigned char *image, unsigned int length,
+	unsigned int timestamp)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_WEBCAM);
 	unsigned char *packet;
 	unsigned char header_len = 13;
@@ -4920,8 +4572,8 @@
 	packet[pos++] = header_len;
 	packet[pos++] = 0;
-	packet[pos++] = 5; /* version byte?? */
+	packet[pos++] = 5;	/* version byte?? */
 	packet[pos++] = 0;
 	pos += yahoo_put32(packet + pos, length);
-	packet[pos++] = 2; /* packet type, image */
+	packet[pos++] = 2;	/* packet type, image */
 	pos += yahoo_put32(packet + pos, timestamp);
 	yahoo_add_to_send_queue(yid, packet, header_len);
@@ -4932,7 +4584,8 @@
 }
 
-void yahoo_webcam_accept_viewer(int id, const char* who, int accept)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_WEBCAM);
+void yahoo_webcam_accept_viewer(int id, const char *who, int accept)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_WEBCAM);
 	char *packet = NULL;
 	char *data = NULL;
@@ -4945,5 +4598,5 @@
 
 	data = strdup("u=");
-	data = y_string_append(data, (char*)who);
+	data = y_string_append(data, (char *)who);
 	data = y_string_append(data, "\r\n");
 	len = strlen(data);
@@ -4952,8 +4605,8 @@
 	packet[pos++] = header_len;
 	packet[pos++] = 0;
-	packet[pos++] = 5; /* version byte?? */
+	packet[pos++] = 5;	/* version byte?? */
 	packet[pos++] = 0;
 	pos += yahoo_put32(packet + pos, len);
-	packet[pos++] = 0; /* packet type */
+	packet[pos++] = 0;	/* packet type */
 	pos += yahoo_put32(packet + pos, accept);
 	memcpy(packet + pos, data, len);
@@ -4965,11 +4618,13 @@
 void yahoo_webcam_invite(int id, const char *who)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_packet *pkt;
-		
-	if(!yid)
-		return;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_NOTIFY, YAHOO_STATUS_NOTIFY, yid->yd->session_id);
+
+	if (!yid)
+		return;
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_NOTIFY, YPACKET_STATUS_NOTIFY,
+		yid->yd->session_id);
 
 	yahoo_packet_hash(pkt, 49, "WEBCAMINVITE");
@@ -4983,5 +4638,6 @@
 }
 
-static void yahoo_search_internal(int id, int t, const char *text, int g, int ar, int photo, int yahoo_only, int startpos, int total)
+static void yahoo_search_internal(int id, int t, const char *text, int g,
+	int ar, int photo, int yahoo_only, int startpos, int total)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
@@ -4991,5 +4647,5 @@
 	char *ctext, *p;
 
-	if(!yd)
+	if (!yd)
 		return;
 
@@ -4999,17 +4655,19 @@
 
 	/*
-	age range
-	.ar=1 - 13-18, 2 - 18-25, 3 - 25-35, 4 - 35-50, 5 - 50-70, 6 - 70+
-	*/
-
-	snprintf(buff, sizeof(buff), "&.sq=%%20&.tt=%d&.ss=%d", total, startpos);
+	   age range
+	   .ar=1 - 13-18, 2 - 18-25, 3 - 25-35, 4 - 35-50, 5 - 50-70, 6 - 70+
+	 */
+
+	snprintf(buff, sizeof(buff), "&.sq=%%20&.tt=%d&.ss=%d", total,
+		startpos);
 
 	ctext = strdup(text);
-	while((p = strchr(ctext, ' ')))
+	while ((p = strchr(ctext, ' ')))
 		*p = '+';
 
-	snprintf(url, 1024, "http://members.yahoo.com/interests?.oc=m&.kw=%s&.sb=%d&.g=%d&.ar=0%s%s%s",
-			ctext, t, g, photo ? "&.p=y" : "", yahoo_only ? "&.pg=y" : "",
-			startpos ? buff : "");
+	snprintf(url, 1024,
+		"http://members.yahoo.com/interests?.oc=m&.kw=%s&.sb=%d&.g=%d&.ar=0%s%s%s",
+		ctext, t, g, photo ? "&.p=y" : "", yahoo_only ? "&.pg=y" : "",
+		startpos ? buff : "");
 
 	FREE(ctext);
@@ -5018,17 +4676,20 @@
 
 	inputs = y_list_prepend(inputs, yid);
-	yahoo_http_get(yid->yd->client_id, url, buff, _yahoo_http_connected, yid);
-}
-
-void yahoo_search(int id, enum yahoo_search_type t, const char *text, enum yahoo_search_gender g, enum yahoo_search_agerange ar, 
-		int photo, int yahoo_only)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	yahoo_http_get(yid->yd->client_id, url, buff, 0, 0,
+		_yahoo_http_connected, yid);
+}
+
+void yahoo_search(int id, enum yahoo_search_type t, const char *text,
+	enum yahoo_search_gender g, enum yahoo_search_agerange ar, int photo,
+	int yahoo_only)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_search_state *yss;
 
-	if(!yid)
-		return;
-
-	if(!yid->ys)
+	if (!yid)
+		return;
+
+	if (!yid->ys)
 		yid->ys = y_new0(struct yahoo_search_state, 1);
 
@@ -5048,38 +4709,143 @@
 void yahoo_search_again(int id, int start)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_search_state *yss;
 
-	if(!yid || !yid->ys)
+	if (!yid || !yid->ys)
 		return;
 
 	yss = yid->ys;
 
-	if(start == -1)
+	if (start == -1)
 		start = yss->lsearch_nstart + yss->lsearch_nfound;
 
-	yahoo_search_internal(id, yss->lsearch_type, yss->lsearch_text, 
-			yss->lsearch_gender, yss->lsearch_agerange, 
-			yss->lsearch_photo, yss->lsearch_yahoo_only, 
-			start, yss->lsearch_ntotal);
-}
+	yahoo_search_internal(id, yss->lsearch_type, yss->lsearch_text,
+		yss->lsearch_gender, yss->lsearch_agerange,
+		yss->lsearch_photo, yss->lsearch_yahoo_only,
+		start, yss->lsearch_ntotal);
+}
+
+void yahoo_send_picture(int id, const char *name, unsigned long size,
+	yahoo_get_fd_callback callback, void *data)
+{
+	/* Not Implemented */
+}
+
+/* File Transfer */
+static YList *active_file_transfers = NULL;
+
+enum {
+	FT_STATE_HEAD = 1,
+	FT_STATE_RECV,
+	FT_STATE_RECV_START,
+	FT_STATE_SEND
+};
 
 struct send_file_data {
-	struct yahoo_packet *pkt;
+	int client_id;
+	char *id;
+	char *who;
+	char *filename;
+	char *ip_addr;
+	char *token;
+	int size;
+
+	struct yahoo_input_data *yid;
+	int state;
+
 	yahoo_get_fd_callback callback;
-	void *user_data;
+	void *data;
 };
 
-static void _yahoo_send_picture_connected(int id, int fd, int error, void *data)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_FT);
+static char *yahoo_get_random(void)
+{
+	int i = 0;
+	int r = 0;
+	int c = 0;
+	char out[25];
+
+	out[24] = '\0';
+	out[23] = '$';
+	out[22] = '$';
+	
+	for (i = 0; i < 22; i++) {
+		if(r == 0)
+			r = rand();
+
+		c = r%61;
+
+		if(c<26)
+			out[i] = c + 'a';
+		else if (c<52)
+			out[i] = c - 26 + 'A';
+		else
+			out[i] = c - 52 + '0';
+
+		r /= 61;
+	}
+
+	return strdup(out);
+}
+
+static int _are_same_id(const void *sfd1, const void *id)
+{
+	return strcmp(((struct send_file_data *)sfd1)->id, (char *)id);
+}
+
+static int _are_same_yid(const void *sfd1, const void *yid)
+{
+	if(((struct send_file_data *)sfd1)->yid == yid)
+		return 0;
+	else
+		return 1;
+}
+
+static struct send_file_data *yahoo_get_active_transfer(char *id)
+{
+	YList *l = y_list_find_custom(active_file_transfers, id,
+		_are_same_id);
+
+	if(l)
+		return (struct send_file_data *)l->data;
+	
+	return NULL;
+}
+
+static struct send_file_data *yahoo_get_active_transfer_with_yid(void *yid)
+{
+	YList *l = y_list_find_custom(active_file_transfers, yid,
+		_are_same_yid);
+
+	if(l)
+		return (struct send_file_data *)l->data;
+	
+	return NULL;
+}
+
+static void yahoo_add_active_transfer(struct send_file_data *sfd)
+{
+	active_file_transfers = y_list_prepend(active_file_transfers, sfd);
+}
+
+static void yahoo_remove_active_transfer(struct send_file_data *sfd)
+{
+	if (sfd == NULL)
+		return;
+	
+	active_file_transfers = y_list_remove(active_file_transfers, sfd);
+	free(sfd->id);
+	free(sfd->who);
+	free(sfd->filename);
+	free(sfd->ip_addr);
+	FREE(sfd);
+}
+
+static void _yahoo_ft_upload_connected(int id, void *fd, int error, void *data)
+{
 	struct send_file_data *sfd = data;
-	struct yahoo_packet *pkt = sfd->pkt;
-	unsigned char buff[1024];
-
-	if(fd <= 0) {
-		sfd->callback(id, fd, error, sfd->user_data);
-		FREE(sfd);
-		yahoo_packet_free(pkt);
+	struct yahoo_input_data *yid = sfd->yid;
+
+	if (!fd) {
 		inputs = y_list_remove(inputs, yid);
 		FREE(yid);
